unit Charoom_F;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,Registry,Jpeg, StdCtrls, Buttons,IniFiles;

type
  TCharoom = class
  private
    SaveFile,
    ImgDir: String;
    TileWall: String;
    Apply: Boolean;

    procedure ReadIniFile;
    function SelectFile: String;
    procedure WriteReg;
  public
    constructor Create;
    procedure Init;
  end;

var
  Charoom: TCharoom;

implementation

constructor TCharoom.Create;
begin
  inherited;
  Init;
end;

procedure TCharoom.Init;
var
  ImgFile: String;
  Image1: TImage;
  Image2: TImage;
begin
  ReadIniFile;
  ImgFile:=SelectFile;
  if ImgFile='' then Exit;

  Image1:=TImage.Create(nil);
  Image2:=TImage.Create(nil);
  try
    Image1.Picture.LoadFromFile(ImgFile);
  except
    on EInvalidGraphic do
      Image1.Picture.Graphic := nil;
  end;

  // Bmpւ̕ϊ
  // JpgSaveToFilełjpg摜ɂȂĂ܂
  Image2.Picture.Bitmap.assign(Image1.Picture.Graphic);
  Image2.Picture.SaveToFile(SaveFile);

  // WXg
  // TileWallPaperLɂ邽
  // SystemParametersInfoɏ
  WriteReg;

  // ǎɔf
  if Apply then
    SystemParametersInfo(SPI_SETDESKWALLPAPER,0,
    PChar(SaveFile),SPIF_SENDCHANGE);
end;

// IniFileǂݏo
procedure TCharoom.ReadIniFile;
var
  IniFile: TIniFile;
  CrntPath: String;
begin
  CrntPath:=ExtractFilePath(Application.ExeName);
  SaveFile:='';
  ImgDir:='';
  TileWall:='0';
//  if FileExists(CrntPath+'Charoom.ini') then begin
  IniFile:=TIniFile.Create(CrntPath+'Charoom.ini');
  SaveFile:=IniFile.ReadString('Images','SaveFile',CrntPath+'Charoom Wallpaper.bmp');
  ImgDir  :=IniFile.ReadString('Images','ImgDir'  ,CrntPath+'images');
  TileWall:=IniFile.ReadString('Images','TileWall','0');
  Apply   :=IniFile.ReadBool('Images','Apply',False);

  // ꉞł
  IniFile.WriteString('Images','SaveFile',SaveFile);
  IniFile.WriteString('Images','ImgDir'  ,ImgDir);
  IniFile.WriteString('Images','TileWall',TileWall);
  IniFile.WriteBool('Images','Apply',Apply);
  IniFile.UpdateFile;
//  end;
  IniFile.Free;
end;

// ǎt@CI
function TCharoom.SelectFile: String;

var
  ImgFiles: TStringList;
  SrchRec: TSearchRec;
  FileNum: Integer;
begin
  ImgFiles:=TStringList.Create;
  // BmpFile
  if FindFirst(ImgDir+'\*.bmp',0,SrchRec)=0 then begin
    ImgFiles.Add(SrchRec.Name);
    while FindNext(SrchRec)=0 do begin
      ImgFiles.Add(SrchRec.Name);
    end;
    FindClose(SrchRec);
  end;
  // JpgFile
  if FindFirst(ImgDir+'\*.jpg',0,SrchRec)=0 then begin
    ImgFiles.Add(SrchRec.Name);
    while FindNext(SrchRec)=0 do begin
      ImgFiles.Add(SrchRec.Name);
    end;
    FindClose(SrchRec);
  end;
  // JpegFile
  if FindFirst(ImgDir+'\*.jpeg',0,SrchRec)=0 then begin
    ImgFiles.Add(SrchRec.Name);
    while FindNext(SrchRec)=0 do begin
      ImgFiles.Add(SrchRec.Name);
    end;
    FindClose(SrchRec);
  end;

  if ImgFiles.Count=0 then begin
    Result:='';
    Exit;
  end;

  // _I
  Randomize;
  FileNum:=Random(ImgFiles.Count);
  Result:=ImgDir+'\'+ImgFiles[FileNum];
end;

// WXg
procedure TCharoom.WriteReg;
var
  Reg: TRegistry;
begin
  Reg:=TRegistry.Create;
  Reg.OpenKey('\Control Panel\Desktop',False);
  Reg.WriteString('TileWallpaper',TileWall);
  Reg.WriteString('Wallpaper',SaveFile);
  Reg.CloseKey;
  Reg.Free;
end;


initialization
  Charoom:=TCharoom.Create;
finalization
  Charoom.Free;

end.
